Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.7.1 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jivesoftware.openfire.pubsub
Class PubSubModule

    java.lang.Object
      org.jivesoftware.openfire.container.BasicModule
          org.jivesoftware.openfire.pubsub.PubSubModule

All Implemented Interfaces:
  ChannelHandler, ClusterEventListener, Module, DiscoInfoProvider, DiscoItemsProvider, ServerItemsProvider, PubSubService, RoutableChannelHandler, PropertyEventListener

    public class PubSubModule

extends BasicModule
implements ServerItemsProvider, DiscoInfoProvider, DiscoItemsProvider, RoutableChannelHandler, PubSubService, ClusterEventListener, PropertyEventListener

Module that implements JEP-60: Publish-Subscribe. By default node collections and instant nodes are supported.

Author:
  Matt Tucker

Constructor Summary
`PubSubModule()`

Method Summary
`void` | `addNode(Node node)` Adds an already persistent node to the service.
`void` | `addSysadmin(String userJID)`
`void` | `addUserAllowedToCreate(String userJID)`
`void` | `broadcast(Node node, org.xmpp.packet.Message message, Collection<org.xmpp.packet.JID> jids)` Broadcasts the specified Message containing an event notification to a list of subscribers to the specified node.
`boolean` | `canCreateNode(org.xmpp.packet.JID creator)` Returns true if the pubsub service allows the specified user to create nodes.
`org.xmpp.packet.JID` | `getAddress()` Returns the XMPP address of the service.
`Map<String,Map<String,String>>` | `getBarePresences()` Returns a registry of the presence's show value of users that subscribed to a node of the pubsub service and for which the node only delivers notifications for online users or node subscriptions deliver events based on the user presence show value.
`DefaultNodeConfiguration` | `getDefaultNodeConfiguration(boolean leafType)` Returns the default node configuration for the specified node type or `null` if the specified node type is not supported by the service.
`org.xmpp.forms.DataForm` | `getExtendedInfo(String name, String node, org.xmpp.packet.JID senderJID)` Returns an XDataForm with the extended information about the entity or null if none.
`Iterator<String>` | `getFeatures(String name, String node, org.xmpp.packet.JID senderJID)` Returns an Iterator (of String) with the supported features.
`Iterator<org.dom4j.Element>` | `getIdentities(String name, String node, org.xmpp.packet.JID senderJID)` Returns an Iterator (of Element) with the target entity's identities.
`Iterator<DiscoServerItem>` | `getItems()` Returns an Iterator (of DiscoServerItem) with the items associated with the server or null if none.
`Iterator<DiscoItem>` | `getItems(String name, String node, org.xmpp.packet.JID senderJID)` Returns an Iterator (of DiscoItem) with the target entity's items or null if none.
`int` | `getItemsTaskTimeout()` Returns the timeout value for the published items maintenance task.
`Queue<PublishedItem>` | `getItemsToAdd()` Gets the queue that holds the items that need to be added to the database.
`Queue<PublishedItem>` | `getItemsToDelete()` Gets the queue that holds the items that need to be deleted from the database.
`AdHocCommandManager` | `getManager()` Returns the ad-hoc commands manager used for this service.
`Node` | `getNode(String nodeID)` Returns the `Node` that matches the specified node ID or `null` if none was found.
`Collection<Node>` | `getNodes()` Retuns the collection of nodes hosted by the pubsub service.
`PublishedItemTask` | `getPublishedItemTask()` Returns the published item task used for this service.
`CollectionNode` | `getRootCollectionNode()` Returns the `CollectionNode` that acts as the root node of the entire node hierarchy.
`String` | `getServiceDomain()`
`String` | `getServiceID()` Returns a String that uniquely identifies this pubsub service.
`String` | `getServiceName()`
`Collection<String>` | `getShowPresences(org.xmpp.packet.JID subscriber)` Returns the show values of the last know presence of all connected resources of the specified subscriber.
`Collection<String>` | `getSysadmins()`
`Timer` | `getTimer()` Returns the timer used for the maintenance process of this service.
`Collection<String>` | `getUsersAllowedToCreate()`
`boolean` | `hasInfo(String name, String node, org.xmpp.packet.JID senderJID)` Returns true if we can provide information related to the requested name and node.
`void` | `initialize(XMPPServer server)` Initializes the basic module.
`boolean` | `isCollectionNodesSupported()` Returns true if the pubsub service supports collection nodes.
`boolean` | `isInstantNodeSupported()` Returns true if the pubsub service allows users to create nodes without specifying the node ID.
`boolean` | `isMultipleSubscriptionsEnabled()` Returns true if a user may have more than one subscription with the node.
`boolean` | `isNodeCreationRestricted()`
`boolean` | `isServiceAdmin(org.xmpp.packet.JID user)` Returns true if the specified user is a sysadmin of the pubsub service or has admin privileges.
`boolean` | `isServiceEnabled()` Returns true if the service is available.
`void` | `joinedCluster()` Notification event indicating that this JVM is now part of a cluster.
`void` | `joinedCluster(byte[] nodeID)` Notification event indicating that another JVM is now part of a cluster.
`void` | `leftCluster()` Notification event indicating that this JVM is no longer part of the cluster.
`void` | `leftCluster(byte[] nodeID)` Notification event indicating that another JVM is no longer part of the cluster.
`void` | `markedAsSeniorClusterMember()` Notification event indicating that this JVM is now the senior cluster member.
`void` | `presenceSubscriptionNotRequired(Node node, org.xmpp.packet.JID user)` Requests the pubsub service to unsubscribe from the presence of the user.
`void` | `presenceSubscriptionRequired(Node node, org.xmpp.packet.JID user)` Requests the pubsub service to subscribe to the presence of the user.
`void` | `process(org.xmpp.packet.Packet packet)` Process an XMPP packet.
`void` | `propertyDeleted(String property, Map<String,Object> params)` A property was deleted.
`void` | `propertySet(String property, Map<String,Object> params)` A property was set.
`void` | `queueItemToAdd(PublishedItem newItem)` Adds the item to the queue of items to add to the database.
`void` | `queueItemToRemove(PublishedItem removedItem)` Adds the item to the queue of items to remove from the database.
`void` | `removeNode(String nodeID)` Removes the specified node from the service.
`void` | `removeSysadmin(String userJID)`
`void` | `removeUserAllowedToCreate(String userJID)`
`void` | `send(org.xmpp.packet.Packet packet)` Sends the specified packet.
`void` | `sendNotification(Node node, org.xmpp.packet.Message message, org.xmpp.packet.JID jid)` Sends the specified Message containing an event notification to a specific subscriber of the specified node.
`void` | `setItemsTaskTimeout(int timeout)` Sets the timeout value for the published items maintenance task.
`void` | `setNodeCreationRestricted(boolean nodeCreationRestricted)`
`void` | `setPublishedItemTask(PublishedItemTask task)` Sets the published item task used for this service.
`void` | `setServiceEnabled(boolean enabled)`
`void` | `start()` Starts the basic module.
`void` | `stop()` Stops the basic module.
`void` | `xmlPropertyDeleted(String property, Map<String,Object> params)` An XML property was deleted.
`void` | `xmlPropertySet(String property, Map<String,Object> params)` An XML property was set.

Methods inherited from class org.jivesoftware.openfire.container.BasicModule
`destroy, getName`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PubSubModule

    public PubSubModule()

Method Detail

### process

    public void process(org.xmpp.packet.Packet packet)

  Description copied from interface: `ChannelHandler`
  Process an XMPP packet.

  Specified by:
    `process` in interface `ChannelHandler`
  Parameters:
    `packet` - a packet to process.

### getServiceID

    public String getServiceID()

  Description copied from interface: `PubSubService`
  Returns a String that uniquely identifies this pubsub service. This information is being used when storing node information in the database so it's possible to have nodes with the same ID but under different pubsub services.

  Specified by:
    `getServiceID` in interface `PubSubService`
  Returns:
    a String that uniquely identifies this pubsub service.

### canCreateNode

    public boolean canCreateNode(org.xmpp.packet.JID creator)

  Description copied from interface: `PubSubService`
  Returns true if the pubsub service allows the specified user to create nodes.

  Specified by:
    `canCreateNode` in interface `PubSubService`
  Parameters:
    `creator` - the JID of the entity trying to create a new node.
  Returns:
    true if the pubsub service allows the specified user to create nodes.

### isServiceAdmin

    public boolean isServiceAdmin(org.xmpp.packet.JID user)

  Description copied from interface: `PubSubService`
  Returns true if the specified user is a sysadmin of the pubsub service or has admin privileges.

  Specified by:
    `isServiceAdmin` in interface `PubSubService`
  Parameters:
    `user` - the user to check if he has admin privileges.
  Returns:
    true if the specified user is a sysadmin of the pubsub service or has admin privileges.

### isInstantNodeSupported

    public boolean isInstantNodeSupported()

  Description copied from interface: `PubSubService`
  Returns true if the pubsub service allows users to create nodes without specifying the node ID. The service will create a random node ID and assigne it to the node.

  Specified by:
    `isInstantNodeSupported` in interface `PubSubService`
  Returns:
    true if the pubsub service allows users to create nodes without specifying the node ID.

### isCollectionNodesSupported

    public boolean isCollectionNodesSupported()

  Description copied from interface: `PubSubService`
  Returns true if the pubsub service supports collection nodes. When collection nodes is supported it is possible to create hierarchy of nodes where a `CollectionNode` may only hold children nodes of type `CollectionNode` or `LeafNode`. On the other hand, `LeafNode` can only hold `PublishedItem`.

  Specified by:
    `isCollectionNodesSupported` in interface `PubSubService`
  Returns:
    true if the pubsub service supports collection nodes.

### getRootCollectionNode

    public CollectionNode getRootCollectionNode()

  Description copied from interface: `PubSubService`
  Returns the `CollectionNode` that acts as the root node of the entire node hierarchy. The returned node does not have a node identifier. If collection nodes is not supported then return `null`.

  Specified by:
    `getRootCollectionNode` in interface `PubSubService`
  Returns:
    the CollectionNode that acts as the root node of the entire node hierarchy or `null` if collection nodes is not supported.

### getDefaultNodeConfiguration

    public DefaultNodeConfiguration getDefaultNodeConfiguration(boolean leafType)

  Description copied from interface: `PubSubService`
  Returns the default node configuration for the specified node type or `null` if the specified node type is not supported by the service.

  Specified by:
    `getDefaultNodeConfiguration` in interface `PubSubService`
  Parameters:
    `leafType` - true when requesting default configuration of leaf nodes
  Returns:
    the default node configuration for the specified node type or `null` if the specified node type is not supported by the service.

### getShowPresences

    public Collection<String> getShowPresences(org.xmpp.packet.JID subscriber)

  Description copied from interface: `PubSubService`
  Returns the show values of the last know presence of all connected resources of the specified subscriber. When the subscriber JID is a bare JID then the answered collection will have many entries one for each connected resource. Moreover, if the user is offline then an empty collectin is returned. Available show status is represented by a `online` value. The rest of the possible show values as defined in RFC 3921.

  Specified by:
    `getShowPresences` in interface `PubSubService`
  Parameters:
    `subscriber` - the JID of the subscriber. This is not the JID of the affiliate.
  Returns:
    an empty collection when offline. Otherwise, a collection with the show value of each connected resource.

### presenceSubscriptionNotRequired

    public void presenceSubscriptionNotRequired(Node node,
                                                org.xmpp.packet.JID user)

  Description copied from interface: `PubSubService`
  Requests the pubsub service to unsubscribe from the presence of the user. If the service was not subscribed to the user's presence or any node still requires to be subscribed to the user presence then do nothing.

  Specified by:
    `presenceSubscriptionNotRequired` in interface `PubSubService`
  Parameters:
    `node` - the node that originated the unsubscription request.
    `user` - the JID of the affiliate to unsubscribe from his presence.

### presenceSubscriptionRequired

    public void presenceSubscriptionRequired(Node node,
                                             org.xmpp.packet.JID user)

  Description copied from interface: `PubSubService`
  Requests the pubsub service to subscribe to the presence of the user. If the service has already subscribed to the user's presence then do nothing.

  Specified by:
    `presenceSubscriptionRequired` in interface `PubSubService`
  Parameters:
    `node` - the node that originated the subscription request.
    `user` - the JID of the affiliate to subscribe to his presence.

### queueItemToAdd

    public void queueItemToAdd(PublishedItem newItem)

  Description copied from interface: `PubSubService`
  Adds the item to the queue of items to add to the database. The queue is going to be processed by another thread.

  Specified by:
    `queueItemToAdd` in interface `PubSubService`
  Parameters:
    `newItem` - the item to add to the database.

### queueItemToRemove

    public void queueItemToRemove(PublishedItem removedItem)

  Description copied from interface: `PubSubService`
  Adds the item to the queue of items to remove from the database. The queue is going to be processed by another thread.

  Specified by:
    `queueItemToRemove` in interface `PubSubService`
  Parameters:
    `removedItem` - the item to remove from the database.

### getServiceName

    public String getServiceName()

### getServiceDomain

    public String getServiceDomain()

### getAddress

    public org.xmpp.packet.JID getAddress()

  Description copied from interface: `PubSubService`
  Returns the XMPP address of the service.

  Specified by:
    `getAddress` in interface `PubSubService`
  Specified by:
    `getAddress` in interface `RoutableChannelHandler`
  Returns:
    the XMPP address of the service.

### getUsersAllowedToCreate

    public Collection<String> getUsersAllowedToCreate()

### getSysadmins

    public Collection<String> getSysadmins()

### addSysadmin

    public void addSysadmin(String userJID)

### removeSysadmin

    public void removeSysadmin(String userJID)

### isNodeCreationRestricted

    public boolean isNodeCreationRestricted()

### isMultipleSubscriptionsEnabled

    public boolean isMultipleSubscriptionsEnabled()

  Description copied from interface: `PubSubService`
  Returns true if a user may have more than one subscription with the node. When multiple subscriptions is enabled each subscription request, event notification and unsubscription request should include a `subid` attribute.

  Specified by:
    `isMultipleSubscriptionsEnabled` in interface `PubSubService`
  Returns:
    true if a user may have more than one subscription with the node.

### setNodeCreationRestricted

    public void setNodeCreationRestricted(boolean nodeCreationRestricted)

### addUserAllowedToCreate

    public void addUserAllowedToCreate(String userJID)

### removeUserAllowedToCreate

    public void removeUserAllowedToCreate(String userJID)

### initialize

    public void initialize(XMPPServer server)

  Description copied from class: `BasicModule`

  Initializes the basic module.

  Inheriting classes that choose to override this method MUST call this initialize() method before accessing BasicModule resources.

  Specified by:
    `initialize` in interface `Module`
  Overrides:
    `initialize` in class `BasicModule`
  Parameters:
    `server` - the server hosting this module.

### start

    public void start()

  Description copied from class: `BasicModule`

  Starts the basic module.

  Inheriting classes that choose to override this method MUST call this start() method before accessing BasicModule resources.

  Specified by:
    `start` in interface `Module`
  Overrides:
    `start` in class `BasicModule`

### stop

    public void stop()

  Description copied from class: `BasicModule`

  Stops the basic module.

  Inheriting classes that choose to override this method MUST call this stop() method before accessing BasicModule resources.

  Specified by:
    `stop` in interface `Module`
  Overrides:
    `stop` in class `BasicModule`

### setServiceEnabled

    public void setServiceEnabled(boolean enabled)

### isServiceEnabled

    public boolean isServiceEnabled()

  Returns true if the service is available. Use `setServiceEnabled(boolean)` to enable or disable the service.

  Returns:
    true if the MUC service is available.

### joinedCluster

    public void joinedCluster()

  Description copied from interface: `ClusterEventListener`
  Notification event indicating that this JVM is now part of a cluster. At this point the `XMPPServer.getNodeID()` holds the new nodeID value.

  When joining the cluster as the senior cluster member the `ClusterEventListener.markedAsSeniorClusterMember()` event will be sent right after this event.

  At this point the CacheFactory holds clustered caches. That means that modifications to the caches will be reflected in the cluster. The clustered caches were just obtained from the cluster and no local cached data was automatically moved.

  Specified by:
    `joinedCluster` in interface `ClusterEventListener`

### joinedCluster

    public void joinedCluster(byte[] nodeID)

  Description copied from interface: `ClusterEventListener`
  Notification event indicating that another JVM is now part of a cluster.

  At this point the CacheFactory of the new node holds clustered caches. That means that modifications to the caches of this JVM will be reflected in the cluster and in particular in the new node.

  Specified by:
    `joinedCluster` in interface `ClusterEventListener`
  Parameters:
    `nodeID` - ID of the node that joined the cluster.

### leftCluster

    public void leftCluster()

  Description copied from interface: `ClusterEventListener`
  Notification event indicating that this JVM is no longer part of the cluster. This could happen when disabling clustering support, removing the enterprise plugin that provides clustering support or connection to cluster got lost.

  Moreover, if we were in a "split brain" scenario (ie. separated cluster islands) and the island were this JVM belonged was marked as "old" then all nodes of that island will get the `left cluster event` and `joined cluster events`. That means that caches will be reset and thus will need to be repopulated again with fresh data from this JVM. This also includes the case where this JVM was the senior cluster member and when the islands met again then this JVM stopped being the senior member.

  At this point the CacheFactory holds local caches. That means that modifications to the caches will only affect this JVM.

  Specified by:
    `leftCluster` in interface `ClusterEventListener`

### leftCluster

    public void leftCluster(byte[] nodeID)

  Description copied from interface: `ClusterEventListener`
  Notification event indicating that another JVM is no longer part of the cluster. This could happen when disabling clustering support, removing the enterprise plugin that provides clustering support or connection to cluster got lost.

  Moreover, if we were in a "split brain" scenario (ie. separated cluster islands) and the island were the other JVM belonged was marked as "old" then all nodes of that island will get the `left cluster event` and `joined cluster events`. That means that caches will be reset and thus will need to be repopulated again with fresh data from this JVM. This also includes the case where the other JVM was the senior cluster member and when the islands met again then the other JVM stopped being the senior member.

  At this point the CacheFactory of the leaving node holds local caches. That means that modifications to the caches of this JVM will not affect the leaving node but other cluster members.

  Specified by:
    `leftCluster` in interface `ClusterEventListener`
  Parameters:
    `nodeID` - ID of the node that is left the cluster.

### markedAsSeniorClusterMember

    public void markedAsSeniorClusterMember()

  Description copied from interface: `ClusterEventListener`
  Notification event indicating that this JVM is now the senior cluster member. This could either happen when initially joining the cluster or when the senior cluster member node left the cluster and this JVM was marked as the new senior cluster member.

  Moreover, in the case of a "split brain" scenario (ie. separated cluster islands) each island will have its own senior cluster member. However, when the islands meet again there could only be one senior cluster member so one of the senior cluster members will stop playing that role. When that happens the JVM no longer playing that role will receive the `ClusterEventListener.leftCluster()` and `ClusterEventListener.joinedCluster()` events.

  Specified by:
    `markedAsSeniorClusterMember` in interface `ClusterEventListener`

### getItems

    public Iterator<DiscoServerItem> getItems()

  Description copied from interface: `ServerItemsProvider`
  Returns an Iterator (of DiscoServerItem) with the items associated with the server or null if none.

  Specified by:
    `getItems` in interface `ServerItemsProvider`
  Returns:
    an Iterator (of DiscoServerItem) with the items associated with the server or null if none.

### getIdentities

    public Iterator<org.dom4j.Element> getIdentities(String name,
                                                     String node,
                                                     org.xmpp.packet.JID senderJID)

  Description copied from interface: `DiscoInfoProvider`
  Returns an Iterator (of Element) with the target entity's identities. Each Element must include the categoty, type and name attributes of the entity.

  Specified by:
    `getIdentities` in interface `DiscoInfoProvider`
  Parameters:
    `name` - the recipient JID's name.
    `node` - the requested disco node.
    `senderJID` - the XMPPAddress of user that sent the disco info request.
  Returns:
    an Iterator (of Element) with the target entity's identities.

### getFeatures

    public Iterator<String> getFeatures(String name,
                                        String node,
                                        org.xmpp.packet.JID senderJID)

  Description copied from interface: `DiscoInfoProvider`
  Returns an Iterator (of String) with the supported features. The features to include are the features offered and supported protocols by the target entity identified by the requested name and node.

  Specified by:
    `getFeatures` in interface `DiscoInfoProvider`
  Parameters:
    `name` - the recipient JID's name.
    `node` - the requested disco node.
    `senderJID` - the XMPPAddress of user that sent the disco info request.
  Returns:
    an Iterator (of String) with the supported features.

### getExtendedInfo

    public org.xmpp.forms.DataForm getExtendedInfo(String name,
                                                   String node,
                                                   org.xmpp.packet.JID senderJID)

  Description copied from interface: `DiscoInfoProvider`
  Returns an XDataForm with the extended information about the entity or null if none. Each bit of information about the entity must be included as a value of a field of the form.

  Specified by:
    `getExtendedInfo` in interface `DiscoInfoProvider`
  Parameters:
    `name` - the recipient JID's name.
    `node` - the requested disco node.
    `senderJID` - the XMPPAddress of user that sent the disco info request.
  Returns:
    an XDataForm with the extended information about the entity or null if none.

### hasInfo

    public boolean hasInfo(String name,
                           String node,
                           org.xmpp.packet.JID senderJID)

  Description copied from interface: `DiscoInfoProvider`
  Returns true if we can provide information related to the requested name and node. For example, if the requested name refers to a non-existant MUC room then the answer will be false. In case that the sender of the disco request is not authorized to discover this information an UnauthorizedException will be thrown.

  Specified by:
    `hasInfo` in interface `DiscoInfoProvider`
  Parameters:
    `name` - the recipient JID's name.
    `node` - the requested disco node.
    `senderJID` - the XMPPAddress of user that sent the disco info request.
  Returns:
    true if we can provide information related to the requested name and node.

### getItems

    public Iterator<DiscoItem> getItems(String name,
                                        String node,
                                        org.xmpp.packet.JID senderJID)

  Description copied from interface: `DiscoItemsProvider`
  Returns an Iterator (of DiscoItem) with the target entity's items or null if none. Each DiscoItem must include a JID attribute and may include the name and node attributes of the entity. In case that the sender of the disco request is not authorized to discover items an UnauthorizedException will be thrown.

  Specified by:
    `getItems` in interface `DiscoItemsProvider`
  Parameters:
    `name` - the recipient JID's name.
    `node` - the requested disco node.
    `senderJID` - the XMPPAddress of user that sent the disco items request.
  Returns:
    an Iterator (of DiscoItem) with the target entity's items or null if none.

### broadcast

    public void broadcast(Node node,
                          org.xmpp.packet.Message message,
                          Collection<org.xmpp.packet.JID> jids)

  Description copied from interface: `PubSubService`
  Broadcasts the specified Message containing an event notification to a list of subscribers to the specified node. Each message being sent has to have a unique ID value so that the service can properly track any notification-related errors that may occur.

  Specified by:
    `broadcast` in interface `PubSubService`
  Parameters:
    `node` - the node that triggered the event notification.
    `message` - the message containing the event notification.
    `jids` - the list of entities to get the event notification.

### send

    public void send(org.xmpp.packet.Packet packet)

  Description copied from interface: `PubSubService`
  Sends the specified packet.

  Specified by:
    `send` in interface `PubSubService`
  Parameters:
    `packet` - the packet to send.

### sendNotification

    public void sendNotification(Node node,
                                 org.xmpp.packet.Message message,
                                 org.xmpp.packet.JID jid)

  Description copied from interface: `PubSubService`
  Sends the specified Message containing an event notification to a specific subscriber of the specified node. The message being sent has to have a unique ID value so that the service can properly track any notification-related errors that may occur.

  Specified by:
    `sendNotification` in interface `PubSubService`
  Parameters:
    `node` - the node that triggered the event notification.
    `message` - the message containing the event notification.
    `jid` - the entity to get the event notification.

### getNode

    public Node getNode(String nodeID)

  Description copied from interface: `PubSubService`
  Returns the `Node` that matches the specified node ID or `null` if none was found.

  Specified by:
    `getNode` in interface `PubSubService`
  Parameters:
    `nodeID` - the ID that uniquely identifies the node in the pubsub service.
  Returns:
    the Node that matches the specified node ID or `null` if none was found.

### getNodes

    public Collection<Node> getNodes()

  Description copied from interface: `PubSubService`
  Retuns the collection of nodes hosted by the pubsub service. The collection does not support modifications.

  Specified by:
    `getNodes` in interface `PubSubService`
  Returns:
    the collection of nodes hosted by the pubsub service.

### addNode

    public void addNode(Node node)

  Description copied from interface: `PubSubService`
  Adds an already persistent node to the service.

  Specified by:
    `addNode` in interface `PubSubService`
  Parameters:
    `node` - the persistent node to add to the service.

### removeNode

    public void removeNode(String nodeID)

  Description copied from interface: `PubSubService`
  Removes the specified node from the service. Most probaly the node was deleted from the database as well.

  A future version may support unloading of inactive nodes even though they may still exist in the database.

  Specified by:
    `removeNode` in interface `PubSubService`
  Parameters:
    `nodeID` - the ID that uniquely identifies the node in the pubsub service.

### getBarePresences

    public Map<String,Map<String,String>> getBarePresences()

  Description copied from interface: `PubSubService`
  Returns a registry of the presence's show value of users that subscribed to a node of the pubsub service and for which the node only delivers notifications for online users or node subscriptions deliver events based on the user presence show value. Offline users will not have an entry in the map. Note: Key-> bare JID and Value-> Map whose key is full JID of connected resource and value is show value of the last received presence.

  Specified by:
    `getBarePresences` in interface `PubSubService`
  Returns:
    a registry of the presence's show value of users that subscribed to a node of the pubsub service.

### getItemsToAdd

    public Queue<PublishedItem> getItemsToAdd()

  Description copied from interface: `PubSubService`
  Gets the queue that holds the items that need to be added to the database.

  Specified by:
    `getItemsToAdd` in interface `PubSubService`
  Returns:
    the queue that holds the items that need to be added to the database.

### getItemsToDelete

    public Queue<PublishedItem> getItemsToDelete()

  Description copied from interface: `PubSubService`
  Gets the queue that holds the items that need to be deleted from the database.

  Specified by:
    `getItemsToDelete` in interface `PubSubService`
  Returns:
    the queue that holds the items that need to be deleted from the database.

### getManager

    public AdHocCommandManager getManager()

  Description copied from interface: `PubSubService`
  Returns the ad-hoc commands manager used for this service.

  Specified by:
    `getManager` in interface `PubSubService`
  Returns:
    the ad-hoc commands manager used for this service.

### getPublishedItemTask

    public PublishedItemTask getPublishedItemTask()

  Description copied from interface: `PubSubService`
  Returns the published item task used for this service.

  Specified by:
    `getPublishedItemTask` in interface `PubSubService`
  Returns:
    the published item task used for this service.

### setPublishedItemTask

    public void setPublishedItemTask(PublishedItemTask task)

  Description copied from interface: `PubSubService`
  Sets the published item task used for this service.

  Specified by:
    `setPublishedItemTask` in interface `PubSubService`
  Parameters:
    `task` - the PublishedItemTask to set for this service.

### getTimer

    public Timer getTimer()

  Description copied from interface: `PubSubService`
  Returns the timer used for the maintenance process of this service.

  Specified by:
    `getTimer` in interface `PubSubService`
  Returns:
    the timer used for the maintenance process of this service.

### getItemsTaskTimeout

    public int getItemsTaskTimeout()

  Description copied from interface: `PubSubService`
  Returns the timeout value for the published items maintenance task.

  Specified by:
    `getItemsTaskTimeout` in interface `PubSubService`
  Returns:
    the timeout value for the published items maintenance task.

### setItemsTaskTimeout

    public void setItemsTaskTimeout(int timeout)

  Description copied from interface: `PubSubService`
  Sets the timeout value for the published items maintenance task.

  Specified by:
    `setItemsTaskTimeout` in interface `PubSubService`
  Parameters:
    `timeout` - the timeout value for the published items maintenance task.

### propertySet

    public void propertySet(String property,
                            Map<String,Object> params)

  Description copied from interface: `PropertyEventListener`
  A property was set. The parameter map `params` will contain the the value of the property under the key `value`.

  Specified by:
    `propertySet` in interface `PropertyEventListener`
  Parameters:
    `property` - the name of the property.
    `params` - event parameters.

### propertyDeleted

    public void propertyDeleted(String property,
                                Map<String,Object> params)

  Description copied from interface: `PropertyEventListener`
  A property was deleted.

  Specified by:
    `propertyDeleted` in interface `PropertyEventListener`
  Parameters:
    `property` - the name of the property deleted.
    `params` - event parameters.

### xmlPropertySet

    public void xmlPropertySet(String property,
                               Map<String,Object> params)

  Description copied from interface: `PropertyEventListener`
  An XML property was set. The parameter map `params` will contain the the value of the property under the key `value`.

  Specified by:
    `xmlPropertySet` in interface `PropertyEventListener`
  Parameters:
    `property` - the name of the property.
    `params` - event parameters.

### xmlPropertyDeleted

    public void xmlPropertyDeleted(String property,
                                   Map<String,Object> params)

  Description copied from interface: `PropertyEventListener`
  An XML property was deleted.

  Specified by:
    `xmlPropertyDeleted` in interface `PropertyEventListener`
  Parameters:
    `property` - the name of the property.
    `params` - event parameters.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.7.1 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2008 Jive Software.